var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from 'react';
import classNames from 'classnames';
import useMeasure from 'react-use/lib/useMeasure';
import { cloneElement } from "../_utils/reactNode";
import { Dropmenu } from "../dropdown";
import "./style/adaptive-more.css";
var prefixCls = 'dmc-adaptive-more';
var prefixClsItem = prefixCls + "-item";

var getAttrNum = function getAttrNum(style, key) {
  var val = "" + style.getPropertyValue(key).replace('px', '');
  return val ? parseFloat(val) : 0;
};

var AdaptiveMore = function AdaptiveMore(props) {
  var className = props.className,
      children = props.children,
      renderMore = props.renderMore,
      moreLabel = props.moreLabel,
      getProcess = props.getProcess,
      restProps = __rest(props, ["className", "children", "renderMore", "moreLabel", "getProcess"]);

  var _a = useMeasure(),
      ref = _a[0],
      width = _a[1].width;

  var _b = useMeasure(),
      moreRef = _b[0],
      mWidth = _b[1].width;

  var parentRef = React.useRef(null);
  var widthRef = React.useRef({});
  var all = React.useMemo(function () {
    return React.Children.toArray(children).map(function (it) {
      return cloneElement(it, {
        className: classNames(prefixClsItem, it.props.className)
      });
    });
  }, [children]);

  var _c = React.useState({
    viewList: all,
    hiddenList: []
  }),
      list = _c[0],
      setList = _c[1];

  React.useEffect(function () {
    var widthMap = {};
    var eleList = parentRef.current.querySelectorAll("." + prefixClsItem);
    all.forEach(function (it, index) {
      var ist = window.getComputedStyle(eleList[index]);
      widthMap[it.key] = getAttrNum(ist, 'width') + getAttrNum(ist, 'margin-left') + getAttrNum(ist, 'margin-right');
    });
    widthRef.current = widthMap;
  }, [all]);
  React.useEffect(function () {
    var wdTotal = 0;
    var vl = [];
    var hl = [];
    all.forEach(function (it) {
      var w = widthRef.current[it.key] || 0;
      wdTotal += w;
      wdTotal <= width - (mWidth || 0) ? vl.push(it) : hl.push(it);
    });
    setList({
      viewList: vl,
      hiddenList: hl
    });
  }, [all, width, mWidth, getProcess]);
  var cls = classNames(prefixCls, className);
  var moreNode = renderMore ? renderMore(list.hiddenList) : !!list.hiddenList.length && _jsx(Dropmenu, __assign({
    onlyText: true,
    renderOverlay: function renderOverlay() {
      return _jsx(React.Fragment, {
        children: list.hiddenList
      }, void 0);
    }
  }, {
    children: moreLabel
  }), void 0);
  return _jsxs("div", __assign({}, restProps, {
    ref: ref,
    className: cls
  }, {
    children: [_jsx("div", __assign({
      className: prefixCls + "-hidden",
      ref: parentRef
    }, {
      children: all
    }), void 0), _jsx("div", __assign({
      className: prefixCls + "-inner"
    }, {
      children: list.viewList
    }), void 0), _jsx("div", __assign({
      className: prefixCls + "-more",
      ref: moreRef
    }, {
      children: moreNode
    }), void 0)]
  }), void 0);
};

AdaptiveMore.displayName = 'AdaptiveMore';
export default AdaptiveMore;
var AdaptiveMoreMemo = /*#__PURE__*/React.memo(AdaptiveMore);
AdaptiveMoreMemo.displayName = 'AdaptiveMoreMemo';
export { AdaptiveMoreMemo };

